<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JLineZNodeCompletor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">JLineZNodeCompletor.java</span></div><h1>JLineZNodeCompletor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import java.util.List;

import jline.Completor;

class JLineZNodeCompletor implements Completor {
    private ZooKeeper zk;

<span class="nc" id="L28">    public JLineZNodeCompletor(ZooKeeper zk) {</span>
<span class="nc" id="L29">        this.zk = zk;</span>
<span class="nc" id="L30">    }</span>

    @SuppressWarnings(&quot;unchecked&quot;)
    public int complete(String buffer, int cursor, List candidates) {
        // Guarantee that the final token is the one we're expanding
<span class="nc" id="L35">        buffer = buffer.substring(0,cursor);</span>
<span class="nc" id="L36">        String token = &quot;&quot;;</span>
<span class="nc bnc" id="L37" title="All 2 branches missed.">        if (!buffer.endsWith(&quot; &quot;)) {</span>
<span class="nc" id="L38">            String[] tokens = buffer.split(&quot; &quot;);</span>
<span class="nc bnc" id="L39" title="All 2 branches missed.">            if (tokens.length != 0) {</span>
<span class="nc" id="L40">                token = tokens[tokens.length-1] ;</span>
            }
        }

<span class="nc bnc" id="L44" title="All 2 branches missed.">        if (token.startsWith(&quot;/&quot;)){</span>
<span class="nc" id="L45">            return completeZNode( buffer, token, candidates);</span>
        }
<span class="nc" id="L47">        return completeCommand(buffer, token, candidates);</span>
    }

    private int completeCommand(String buffer, String token,
            List&lt;String&gt; candidates)
    {
<span class="nc bnc" id="L53" title="All 2 branches missed.">        for (String cmd : ZooKeeperMain.getCommands()) {</span>
<span class="nc bnc" id="L54" title="All 2 branches missed.">            if (cmd.startsWith( token )) {</span>
<span class="nc" id="L55">                candidates.add(cmd);</span>
            }
<span class="nc" id="L57">        }</span>
<span class="nc" id="L58">        return buffer.lastIndexOf(&quot; &quot;)+1;</span>
    }

    private int completeZNode( String buffer, String token,
            List&lt;String&gt; candidates)
    {
<span class="nc" id="L64">        String path = token;</span>
<span class="nc" id="L65">        int idx = path.lastIndexOf(&quot;/&quot;) + 1;</span>
<span class="nc" id="L66">        String prefix = path.substring(idx);</span>
        try {
            // Only the root path can end in a /, so strip it off every other prefix
<span class="nc bnc" id="L69" title="All 2 branches missed.">            String dir = idx == 1 ? &quot;/&quot; : path.substring(0,idx-1);</span>
<span class="nc" id="L70">            List&lt;String&gt; children = zk.getChildren(dir, false);</span>
<span class="nc bnc" id="L71" title="All 2 branches missed.">            for (String child : children) {</span>
<span class="nc bnc" id="L72" title="All 2 branches missed.">                if (child.startsWith(prefix)) {</span>
<span class="nc" id="L73">                    candidates.add( child );</span>
                }
<span class="nc" id="L75">            }</span>
<span class="nc" id="L76">        } catch( InterruptedException e) {</span>
<span class="nc" id="L77">            return 0;</span>
        }
<span class="nc" id="L79">        catch( KeeperException e) {</span>
<span class="nc" id="L80">            return 0;</span>
<span class="nc" id="L81">        }</span>
<span class="nc bnc" id="L82" title="All 2 branches missed.">        return candidates.size() == 0 ? buffer.length() : buffer.lastIndexOf(&quot;/&quot;) + 1;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>